#pragma once
#include <iostream>

const int inOffset=10007;
const int outOffset=20007;
extern bool vazi;

struct Edge{
    int a, b;
    int which;
    int x1, y1;
    int x2, y2;
    bool state;

    Edge(int a, int b, int x1, int y1, int x2, int y2, int which){
        this->a = a;
        this->b = b;
        this->x1 = x1;
        this->x2 = x2;
        this->y1 = y1;
        this->y2 = y2;
        this->which = which;
        this->state = false;
    }

    bool& getState() {return state;}
    void setState(bool state) {this->state = state;}

    void render(SDL_Renderer* renderer){
        if(b<inOffset){
            auto rGate = Gate::getObjects()[this->b];
            //if(!ok) {std::cout << "uso sam " << lGate->getId() << " " << rGate->getId() << std::endl; ok=1;}
            if(which==0){
                auto lGate = Gate::getObjects()[this->a];
                //edge = std::make_unique<Edge>(leftNode, rightNode, lGate->getX(), lGate->getY()+16,
                //rGate->getX(), rGate->getY()+32);
                x1 = lGate->getX();
                y1 = lGate->getY()+16;
                x2 = rGate->getX()+128;
                y2 = rGate->getY()+32;
            }
            if(which==1){
                auto lGate = Gate::getObjects()[this->a];
                //edge = std::make_unique<Edge>(leftNode, rightNode, lGate->getX(), lGate->getY()+48,
                //rGate->getX(), rGate->getY()+32);
                x1 = lGate->getX();
                y1 = lGate->getY()+48;
                x2 = rGate->getX()+128;
                y2 = rGate->getY()+32;
                
            }
            if(which==2){
                auto lOut = Output::getOutputs()[this->a-outOffset];
                x1 = lOut->getX();
                y1 = lOut->getY()+32;
                x2 = rGate->getX()+128;
                y2 = rGate->getY()+32;
            }
            SDL_SetRenderDrawColor(renderer, 0, 0, 0, 255);
            SDL_RenderDrawLine(renderer, x1-1, y1+1, x2-1, y2+1);
            SDL_RenderDrawLine(renderer, x1+1, y1-1, x2+1, y2-1);
            if(this->state==true) std::cout << this->a << "-" << this->b << std::endl;
            if(this->state==true) SDL_SetRenderDrawColor(renderer, 52, 154, 250, 255);
            SDL_RenderDrawLine(renderer, x1, y1, x2, y2);
            SDL_RenderDrawLine(renderer, x1, y1-1, x2, y2-1);
            SDL_RenderDrawLine(renderer, x1, y1+1, x2, y2+1);
            SDL_RenderDrawLine(renderer, x1-1, y1, x2-1, y2);
            SDL_RenderDrawLine(renderer, x1+1, y1, x2+1, y2);
        }
        else if(b<outOffset){
            auto rGate = Input::getInputs()[this->b-inOffset];
            //if(!ok) {std::cout << "uso sam " << lGate->getId() << " " << rGate->getId() << std::endl; ok=1;}
            if(which==0){
                auto lGate = Gate::getObjects()[this->a];
                //edge = std::make_unique<Edge>(leftNode, rightNode, lGate->getX(), lGate->getY()+16,
                //rGate->getX(), rGate->getY()+32);
                x1 = lGate->getX();
                y1 = lGate->getY()+16;
                x2 = rGate->getX()+64;
                y2 = rGate->getY()+32;
            }
            if(which==1){
                auto lGate = Gate::getObjects()[this->a];
                //edge = std::make_unique<Edge>(leftNode, rightNode, lGate->getX(), lGate->getY()+48,
                //rGate->getX(), rGate->getY()+32);
                x1 = lGate->getX();
                y1 = lGate->getY()+48;
                x2 = rGate->getX()+64;
                y2 = rGate->getY()+32;
            }
            if(which==2){
                auto lOut = Output::getOutputs()[this->a-outOffset];
                x1 = lOut->getX();
                y1 = lOut->getY()+32;
                x2 = rGate->getX()+64;
                y2 = rGate->getY()+32;
            }
            SDL_SetRenderDrawColor(renderer, 0, 0, 0, 255);
            SDL_RenderDrawLine(renderer, x1-1, y1+1, x2-1, y2+1);
            SDL_RenderDrawLine(renderer, x1+1, y1-1, x2+1, y2-1);
            if(this->state==true) SDL_SetRenderDrawColor(renderer, 52, 154, 250, 255);
            SDL_RenderDrawLine(renderer, x1, y1, x2, y2);
            SDL_RenderDrawLine(renderer, x1, y1-1, x2, y2-1);
            SDL_RenderDrawLine(renderer, x1, y1+1, x2, y2+1);
            SDL_RenderDrawLine(renderer, x1-1, y1, x2-1, y2);
            SDL_RenderDrawLine(renderer, x1+1, y1, x2+1, y2);
            
        }
    }

    bool operator<(const Edge& other) const {
        // Define your comparison logic here
        // For example, compare based on the 'a' member variable
        return a < other.a;
    }

};
